#include "verifier.h"

verifier_modulus vp("170141183460469231731687303715884105727");

void frombytes(crypto_uint32 *x,const crypto_uint8 *s)
{
  x[0] = crypto_uint32(s[0]);
  x[0] += crypto_uint32(s[1]) << 8;
  x[0] += crypto_uint32(s[2]) << 16;
  x[0] += crypto_uint32(s[3]) << 24;
  x[1] = crypto_uint32(s[4]) << 6;
  x[1] += crypto_uint32(s[5]) << 14;
  x[1] += crypto_uint32(s[6]) << 22;
  x[2] = crypto_uint32(s[7]) << 4;
  x[2] += crypto_uint32(s[8]) << 12;
  x[2] += crypto_uint32(s[9]) << 20;
  x[3] = crypto_uint32(s[10]) << 2;
  x[3] += crypto_uint32(s[11]) << 10;
  x[3] += crypto_uint32(s[12]) << 18;
  x[4] = crypto_uint32(s[13]) << 0;
  x[4] += crypto_uint32(s[14]) << 8;
  x[4] += crypto_uint32(s[15]) << 16;
}

void doit(crypto_uint8 *s)
{
  crypto_uint32 x[5];

  verifier_bigint vs;
  for (int i = 0;i < 16;++i) verifier_addlimb(&vs,s[i],i * 8);

  frombytes(x,s);

  verifier_bigint vx;
  for (int i = 0;i < 5;++i) verifier_addlimb(&vx,x[i],i * 26);

  verifier_assertequal(&vs,&vx);
}

main()
{
  crypto_uint8 s[16];

  for (int i = 0;i < 16;++i) s[i].inputunsignedchar();

  doit(s);
}
