#ifndef computation_h
#define computation_h

#include <gmpxx.h>
#include <iostream>

extern long long computation_mask(long long,long);
extern long long computation_xor(long long,long long);
extern long long computation_and(long long,long long);

extern long long computation_negate(long long);
extern long long computation_add(long long,long long);
extern long long computation_sub(long long,long long);
extern long long computation_mul(long long,long long);

extern long long computation_leftshift(long long,long long);
extern long long computation_rightshift(long long,long long);

extern long long computation_uint8(long long);
extern long long computation_uint32(long long);
extern long long computation_uint64(long long);
extern long long computation_int64(long long);
extern long long computation_int32(long long);

extern void computation_cut(long long);

extern long long computation_const(int);

extern long long computation_inputint(void);
extern long long computation_inputunsignedchar(void);

extern void computation_assertconstant(long long,mpz_class);
extern void computation_assertrange(long long,mpz_class,mpz_class);
extern void computation_assumerange(long long,mpz_class,mpz_class);
extern void computation_assumemin(long long,mpz_class);
extern void computation_assumemax(long long,mpz_class);
extern int computation_knownpositive(long long);
extern int computation_knownnonpositive(long long);
extern int computation_knownnegative(long long);
extern int computation_knownnonnegative(long long);

extern void computation_assertequal(long long,long long);
extern void computation_assertequalmod(long long source1,long long source2,mpz_class mod);
extern void computation_assertcswap(long long x,long long y,long long a,long long b,long long c);
extern void computation_assertcmov(long long x,long long a,long long b,long long c);
extern void computation_assertbit(long long b,long long x,long long e);
extern void computation_assertxor(long long c,long long a,long long b);

struct computation_value {
  long long id; // identifier for this value in computation graph
 
  computation_value()
  {
    id = 0;
  }
  computation_value(int c) // constant c in code
  {
    id = computation_const(c);
  }
  computation_value& operator=(int c)
  {
    id = computation_const(c);
    return *this;
  }
  void inputint(void)
  {
    id = computation_inputint();
  }
  void inputunsignedchar(void)
  {
    id = computation_inputunsignedchar();
  }
} ;

#endif
