#ifndef crypto_int32_h
#define crypto_int32_h

#include "computation.h"
#include "crypto_uint8.h"

struct crypto_int32 : computation_value {
  crypto_int32() : computation_value(){}
  crypto_int32(int n) : computation_value(n){}
  crypto_int32(crypto_uint8 x)
   {
    id = x.id;
  }
  crypto_int32& operator=(const computation_value &b)
  {
    this->id = computation_int32(b.id);
    return *this;
  }
  friend crypto_int32 operator+(const crypto_int32 &a,const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_add(a.id,b.id));
    return result;
  }
  friend crypto_int32 operator-(const crypto_int32 &a,const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_sub(a.id,b.id));
    return result;
  }
  crypto_int32& operator+=(const crypto_int32 &x) { *this = *this + x; }
  friend crypto_int32 operator-(const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_negate(b.id));
    return result;
  }
  crypto_int32& operator-=(const crypto_int32 &x) { *this = *this - x; }
  friend crypto_int32 operator*(const crypto_int32 &a,const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_mul(a.id,b.id));
    return result;
  }
  friend crypto_int32 operator^(const crypto_int32 &a,const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_xor(a.id,b.id));
    return result;
  }
  crypto_int32& operator^=(const crypto_int32 &x) { *this = *this ^ x; }
  friend crypto_int32 operator&(const crypto_int32 &a,const crypto_int32 &b)
  {
    crypto_int32 result;
    result.id = computation_int32(computation_and(a.id,b.id));
    return result;
  }
  friend crypto_int32 operator>>(const crypto_int32 &a,long long e)
  {
    crypto_int32 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 32) std::cout << "assert False\n";
    result.id = computation_int32(computation_rightshift(a.id,e));
    return result;
  }
  friend crypto_int32 operator<<(const crypto_int32 &a,long long e)
  {
    crypto_int32 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 32) std::cout << "assert False\n";
    result.id = computation_int32(computation_leftshift(a.id,e));
    return result;
  }
  crypto_int32& operator&=(const crypto_int32 &x) { *this = *this & x; }
} ;

#endif
