#ifndef crypto_int64_h
#define crypto_int64_h

#include "computation.h"
#include "crypto_uint32.h"
#include "crypto_int32.h"

struct crypto_int64 : computation_value {
  crypto_int64() : computation_value(){}
  crypto_int64(int n) : computation_value(n){}
  crypto_int64(crypto_int32 x)
  {
    id = x.id;
  }
  crypto_int64(crypto_uint32 x)
  {
    id = x.id;
  }
  crypto_int64& operator=(const computation_value &b)
  {
    this->id = computation_int64(b.id);
    return *this;
  }
  friend crypto_int64 operator+(const crypto_int64 &a,const crypto_int64 &b)
  {
    crypto_int64 result;
    result.id = computation_int64(computation_add(a.id,b.id));
    return result;
  }
  crypto_int64& operator+=(const crypto_int64 &x) { *this = *this + x; }
  friend crypto_int64 operator-(const crypto_int64 &a,const crypto_int64 &b)
  {
    crypto_int64 result;
    result.id = computation_int64(computation_sub(a.id,b.id));
    return result;
  }
  crypto_int64& operator-=(const crypto_int64 &x) { *this = *this - x; }
  friend crypto_int64 operator*(const crypto_int64 &a,const crypto_int64 &b)
  {
    crypto_int64 result;
    result.id = computation_int64(computation_mul(a.id,b.id));
    return result;
  }
  friend crypto_int64 operator>>(const crypto_int64 &a,long long e)
  {
    crypto_int64 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 64) std::cout << "assert False\n";
    result.id = computation_int64(computation_rightshift(a.id,e));
    return result;
  }
  friend crypto_int64 operator<<(const crypto_int64 &a,long long e)
  {
    crypto_int64 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 64) std::cout << "assert False\n";
    result.id = computation_int64(computation_leftshift(a.id,e));
    return result;
  }
} ;

#endif
