#ifndef crypto_uint32_h
#define crypto_uint32_h

#include "computation.h"
#include "crypto_uint8.h"

struct crypto_uint32 : computation_value {
  crypto_uint32() : computation_value(){}
  crypto_uint32(crypto_uint8 x)
  {
    id = x.id;
  }
  crypto_uint32& operator=(const computation_value &b)
  {
    this->id = computation_uint32(b.id);
    return *this;
  }
  friend crypto_uint32 operator+(const crypto_uint32 &a,const crypto_uint32 &b)
  {
    crypto_uint32 result;
    result.id = computation_uint32(computation_add(a.id,b.id));
    return result;
  }
  crypto_uint32& operator+=(const crypto_uint32 &x) { *this = *this + x; }
  friend crypto_uint32 operator-(const crypto_uint32 &a,const crypto_uint32 &b)
  {
    crypto_uint32 result;
    result.id = computation_uint32(computation_sub(a.id,b.id));
    return result;
  }
  crypto_uint32& operator-=(const crypto_uint32 &x) { *this = *this - x; }
  friend crypto_uint32 operator*(const crypto_uint32 &a,const crypto_uint32 &b)
  {
    crypto_uint32 result;
    result.id = computation_uint32(computation_mul(a.id,b.id));
    return result;
  }
  friend crypto_uint32 operator>>(const crypto_uint32 &a,long long e)
  {
    crypto_uint32 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 32) std::cout << "assert False\n";
    result.id = computation_uint32(computation_rightshift(a.id,e));
    return result;
  }
  friend crypto_uint32 operator<<(const crypto_uint32 &a,long long e)
  {
    crypto_uint32 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 32) std::cout << "assert False\n";
    result.id = computation_uint32(computation_leftshift(a.id,e));
    return result;
  }
} ;

#endif
