#ifndef crypto_uint64_h
#define crypto_uint64_h

#include "computation.h"
#include "crypto_uint8.h"
#include "crypto_uint32.h"

struct crypto_uint64 : computation_value {
  crypto_uint64() : computation_value(){}
  crypto_uint64(crypto_uint8 x)
  {
    id = x.id;
  }
  crypto_uint64(crypto_uint32 x)
  {
    id = x.id;
  }
  crypto_uint64& operator=(const computation_value &b)
  {
    this->id = computation_uint64(b.id);
    return *this;
  }
  friend crypto_uint64 operator+(const crypto_uint64 &a,const crypto_uint64 &b)
  {
    crypto_uint64 result;
    result.id = computation_uint64(computation_add(a.id,b.id));
    return result;
  }
  crypto_uint64& operator+=(const crypto_uint64 &x) { *this = *this + x; }
  friend crypto_uint64 operator-(const crypto_uint64 &a,const crypto_uint64 &b)
  {
    crypto_uint64 result;
    result.id = computation_uint64(computation_sub(a.id,b.id));
    return result;
  }
  crypto_uint64& operator-=(const crypto_uint64 &x) { *this = *this - x; }
  friend crypto_uint64 operator*(const crypto_uint64 &a,const crypto_uint64 &b)
  {
    crypto_uint64 result;
    result.id = computation_uint64(computation_mul(a.id,b.id));
    return result;
  }
  friend crypto_uint64 operator>>(const crypto_uint64 &a,long long e)
  {
    crypto_uint64 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 64) std::cout << "assert False\n";
    result.id = computation_uint64(computation_rightshift(a.id,e));
    return result;
  }
  friend crypto_uint64 operator<<(const crypto_uint64 &a,long long e)
  {
    crypto_uint64 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 64) std::cout << "assert False\n";
    result.id = computation_uint64(computation_leftshift(a.id,e));
    return result;
  }
} ;

#endif
