#ifndef crypto_uint8_h
#define crypto_uint8_h

#include "computation.h"

struct crypto_uint8 : computation_value {
  crypto_uint8() : computation_value(){}
  crypto_uint8& operator=(const computation_value &b)
  {
    this->id = computation_uint8(b.id);
    return *this;
  }
  friend crypto_uint8 operator+(const crypto_uint8 &a,const crypto_uint8 &b)
  {
    crypto_uint8 result;
    result.id = computation_uint8(computation_add(a.id,b.id));
    return result;
  }
  friend crypto_uint8 operator-(const crypto_uint8 &a,const crypto_uint8 &b)
  {
    crypto_uint8 result;
    result.id = computation_uint8(computation_sub(a.id,b.id));
    return result;
  }
  friend crypto_uint8 operator*(const crypto_uint8 &a,const crypto_uint8 &b)
  {
    crypto_uint8 result;
    result.id = computation_uint8(computation_mul(a.id,b.id));
    return result;
  }
  friend crypto_uint8 operator^(const crypto_uint8 &a,const crypto_uint8 &b)
  {
    crypto_uint8 result;
    result.id = computation_uint8(computation_xor(a.id,b.id));
    return result;
  }
  crypto_uint8& operator^=(const crypto_uint8 &x) { *this = *this ^ x; }
  friend crypto_uint8 operator>>(const crypto_uint8 &a,long long e)
  {
    crypto_uint8 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 8) std::cout << "assert False\n";
    result.id = computation_uint8(computation_rightshift(a.id,e));
    return result;
  }
  crypto_uint8& operator>>=(long long e) { *this = *this >> e; }
  friend crypto_uint8 operator<<(const crypto_uint8 &a,long long e)
  {
    crypto_uint8 result;
    if (e < 0) std::cout << "assert False\n";
    if (e >= 8) std::cout << "assert False\n";
    result.id = computation_uint8(computation_leftshift(a.id,e));
    return result;
  }
  crypto_uint8& operator<<=(long long e) { *this = *this << e; }
  friend crypto_uint8 operator&(const crypto_uint8 &a,long mask)
  {
    crypto_uint8 result;
    result.id = computation_uint8(computation_mask(a.id,mask));
    return result;
  }
  crypto_uint8& operator&=(long mask) { *this = *this & mask; }
} ;

#endif
