#include "crypto_int32.h"
#include "verifier.h"
#include "fe.h"

main()
{
  crypto_int32 x1[10];
  crypto_int32 x2[10];
  crypto_int32 z2[10];
  crypto_int32 x3[10];
  crypto_int32 z3[10];
  crypto_int32 tmp0[10];
  crypto_int32 tmp1[10];
  verifier_modulus vp("57896044618658097711785492504343953926634992332820282019728792003956564819949");
  
  for (int i = 0;i < 10;++i) x1[i].inputint();
  for (int i = 0;i < 10;++i) x2[i].inputint();
  for (int i = 0;i < 10;++i) x3[i].inputint();
  for (int i = 0;i < 10;++i) z2[i].inputint();
  for (int i = 0;i < 10;++i) z3[i].inputint();

  for (int i = 0;i < 10;i += 2) verifier_assumerange(x1[i],"-1729625","1729625");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(x1[i],"-564812","554812");
  for (int i = 0;i < 10;i += 2) verifier_assumerange(x2[i],"-1729625","1729625");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(x2[i],"-564812","554812");
  for (int i = 0;i < 10;i += 2) verifier_assumerange(x3[i],"-1729625","1729625");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(x3[i],"-564812","554812");
  for (int i = 0;i < 10;i += 2) verifier_assumerange(z2[i],"-1729625","1729625");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(z2[i],"-564812","554812");
  for (int i = 0;i < 10;i += 2) verifier_assumerange(z3[i],"-1729625","1729625");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(z3[i],"-564812","554812");

/* qhasm: fe X2 */

/* qhasm: fe Z2 */

/* qhasm: fe X3 */

/* qhasm: fe Z3 */

/* qhasm: fe X4 */

/* qhasm: fe Z4 */

/* qhasm: fe X5 */

/* qhasm: fe Z5 */

/* qhasm: fe A */

/* qhasm: fe B */

/* qhasm: fe C */

/* qhasm: fe D */

/* qhasm: fe E */

/* qhasm: fe AA */

/* qhasm: fe BB */

/* qhasm: fe DA */

/* qhasm: fe CB */

/* qhasm: fe t0 */

/* qhasm: fe t1 */

/* qhasm: fe t2 */

/* qhasm: fe t3 */

/* qhasm: fe t4 */

/* qhasm: enter ladder */

  verifier_bigint X1;
  verifier_limbs_10_255(&X1,x1);

  verifier_bigint X2;
  verifier_limbs_10_255(&X2,x2);

  verifier_bigint Z2;
  verifier_limbs_10_255(&Z2,z2);

  verifier_bigint X3;
  verifier_limbs_10_255(&X3,x3);

  verifier_bigint Z3;
  verifier_limbs_10_255(&Z3,z3);

  verifier_bigint a24;
  verifier_addlimb(&a24,crypto_int32(121666),0);

/* qhasm: D = X3-Z3 */
/* asm 1: fe_sub(>D=fe#5,<X3=fe#3,<Z3=fe#4); */
/* asm 2: fe_sub(>D=tmp0,<X3=x3,<Z3=z3); */
fe_sub(tmp0,x3,z3);

  verifier_bigint D;
  verifier_limbs_10_255(&D,tmp0);
  verifier_assertdiff(&D,&X3,&Z3);
  verifier_cutlimbs(tmp0,10);

/* qhasm: B = X2-Z2 */
/* asm 1: fe_sub(>B=fe#6,<X2=fe#1,<Z2=fe#2); */
/* asm 2: fe_sub(>B=tmp1,<X2=x2,<Z2=z2); */
fe_sub(tmp1,x2,z2);

  verifier_bigint B;
  verifier_limbs_10_255(&B,tmp1);
  verifier_assertdiff(&B,&X2,&Z2);
  verifier_cutlimbs(tmp1,10);

/* qhasm: A = X2+Z2 */
/* asm 1: fe_add(>A=fe#1,<X2=fe#1,<Z2=fe#2); */
/* asm 2: fe_add(>A=x2,<X2=x2,<Z2=z2); */
fe_add(x2,x2,z2);

  verifier_bigint A;
  verifier_limbs_10_255(&A,x2);
  verifier_assertsum(&A,&X2,&Z2);
  verifier_cutlimbs(x2,10);

/* qhasm: C = X3+Z3 */
/* asm 1: fe_add(>C=fe#2,<X3=fe#3,<Z3=fe#4); */
/* asm 2: fe_add(>C=z2,<X3=x3,<Z3=z3); */
fe_add(z2,x3,z3);

  verifier_bigint C;
  verifier_limbs_10_255(&C,z2);
  verifier_assertsum(&C,&X3,&Z3);
  verifier_cutlimbs(z2,10);

/* qhasm: DA = D*A */
/* asm 1: fe_mul(>DA=fe#4,<D=fe#5,<A=fe#1); */
/* asm 2: fe_mul(>DA=z3,<D=tmp0,<A=x2); */
fe_mul(z3,tmp0,x2);

  verifier_bigint DA;
  verifier_limbs_10_255(&DA,z3);
  verifier_assertprodmod(&DA,&D,&A,vp);
  verifier_cutlimbs(z3,10);

/* qhasm: CB = C*B */
/* asm 1: fe_mul(>CB=fe#2,<C=fe#2,<B=fe#6); */
/* asm 2: fe_mul(>CB=z2,<C=z2,<B=tmp1); */
fe_mul(z2,z2,tmp1);

  verifier_bigint CB;
  verifier_limbs_10_255(&CB,z2);
  verifier_assertprodmod(&CB,&C,&B,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: BB = B^2 */
/* asm 1: fe_sq(>BB=fe#5,<B=fe#6); */
/* asm 2: fe_sq(>BB=tmp0,<B=tmp1); */
fe_sq(tmp0,tmp1);

  verifier_bigint BB;
  verifier_limbs_10_255(&BB,tmp0);
  verifier_assertprodmod(&BB,&B,&B,vp);
  verifier_cutlimbs(tmp0,10);

/* qhasm: AA = A^2 */
/* asm 1: fe_sq(>AA=fe#6,<A=fe#1); */
/* asm 2: fe_sq(>AA=tmp1,<A=x2); */
fe_sq(tmp1,x2);

  verifier_bigint AA;
  verifier_limbs_10_255(&AA,tmp1);
  verifier_assertprodmod(&AA,&A,&A,vp);
  verifier_cutlimbs(tmp1,10);

/* qhasm: t0 = DA+CB */
/* asm 1: fe_add(>t0=fe#3,<DA=fe#4,<CB=fe#2); */
/* asm 2: fe_add(>t0=x3,<DA=z3,<CB=z2); */
fe_add(x3,z3,z2);

  verifier_bigint t0;
  verifier_limbs_10_255(&t0,x3);
  verifier_assertsum(&t0,&DA,&CB);
  verifier_cutlimbs(x3,10);

/* qhasm: assign x3 to t0 */

/* qhasm: t1 = DA-CB */
/* asm 1: fe_sub(>t1=fe#2,<DA=fe#4,<CB=fe#2); */
/* asm 2: fe_sub(>t1=z2,<DA=z3,<CB=z2); */
fe_sub(z2,z3,z2);

  verifier_bigint t1;
  verifier_limbs_10_255(&t1,z2);
  verifier_assertdiff(&t1,&DA,&CB);
  verifier_cutlimbs(z2,10);

/* qhasm: X4 = AA*BB */
/* asm 1: fe_mul(>X4=fe#1,<AA=fe#6,<BB=fe#5); */
/* asm 2: fe_mul(>X4=x2,<AA=tmp1,<BB=tmp0); */
fe_mul(x2,tmp1,tmp0);

  verifier_bigint X4;
  verifier_limbs_10_255(&X4,x2);
  verifier_assertprodmod(&X4,&AA,&BB,vp);
  verifier_cutlimbs(x2,10);

/* qhasm: E = AA-BB */
/* asm 1: fe_sub(>E=fe#6,<AA=fe#6,<BB=fe#5); */
/* asm 2: fe_sub(>E=tmp1,<AA=tmp1,<BB=tmp0); */
fe_sub(tmp1,tmp1,tmp0);

  verifier_bigint E;
  verifier_limbs_10_255(&E,tmp1);
  verifier_assertdiff(&E,&AA,&BB);
  verifier_cutlimbs(tmp1,10);

/* qhasm: t2 = t1^2 */
/* asm 1: fe_sq(>t2=fe#2,<t1=fe#2); */
/* asm 2: fe_sq(>t2=z2,<t1=z2); */
fe_sq(z2,z2);

  verifier_bigint t2;
  verifier_limbs_10_255(&t2,z2);
  verifier_assertprodmod(&t2,&t1,&t1,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: t3 = a24*E */
/* asm 1: fe_mul121666(>t3=fe#4,<E=fe#6); */
/* asm 2: fe_mul121666(>t3=z3,<E=tmp1); */
fe_mul121666(z3,tmp1);

  verifier_bigint t3;
  verifier_limbs_10_255(&t3,z3);
  verifier_assertprodmod(&t3,&a24,&E,vp);
  verifier_cutlimbs(z3,10);
  
/* qhasm: X5 = t0^2 */
/* asm 1: fe_sq(>X5=fe#3,<t0=fe#3); */
/* asm 2: fe_sq(>X5=x3,<t0=x3); */
fe_sq(x3,x3);

  verifier_bigint X5;
  verifier_limbs_10_255(&X5,x3);
  verifier_assertprodmod(&X5,&t0,&t0,vp);
  verifier_cutlimbs(x3,10);

/* qhasm: t4 = BB+t3 */
/* asm 1: fe_add(>t4=fe#5,<BB=fe#5,<t3=fe#4); */
/* asm 2: fe_add(>t4=tmp0,<BB=tmp0,<t3=z3); */
fe_add(tmp0,tmp0,z3);

  verifier_bigint t4;
  verifier_limbs_10_255(&t4,tmp0);
  verifier_assertsum(&t4,&BB,&t3);
  verifier_cutlimbs(tmp0,10);

/* qhasm: Z5 = X1*t2 */
/* asm 1: fe_mul(>Z5=fe#4,x1,<t2=fe#2); */
/* asm 2: fe_mul(>Z5=z3,x1,<t2=z2); */
fe_mul(z3,x1,z2);

  verifier_bigint Z5;
  verifier_limbs_10_255(&Z5,z3);
  verifier_assertprodmod(&Z5,&X1,&t2,vp);
  verifier_cutlimbs(z3,10);

/* qhasm: Z4 = E*t4 */
/* asm 1: fe_mul(>Z4=fe#2,<E=fe#6,<t4=fe#5); */
/* asm 2: fe_mul(>Z4=z2,<E=tmp1,<t4=tmp0); */
fe_mul(z2,tmp1,tmp0);

  verifier_bigint Z4;
  verifier_limbs_10_255(&Z4,z2);
  verifier_assertprodmod(&Z4,&E,&t4,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: return */

  // XXX: maybe smaller
  for (int i = 0;i < 10;i += 2) verifier_assertrange(x2[i],"-110729625","110729625");
  for (int i = 1;i < 10;i += 2) verifier_assertrange(x2[i],"-55364812","55364812");
  for (int i = 0;i < 10;i += 2) verifier_assertrange(x3[i],"-110729625","110729625");
  for (int i = 1;i < 10;i += 2) verifier_assertrange(x3[i],"-55364812","55364812");
  for (int i = 0;i < 10;i += 2) verifier_assertrange(z2[i],"-110729625","110729625");
  for (int i = 1;i < 10;i += 2) verifier_assertrange(z2[i],"-55364812","55364812");
  for (int i = 0;i < 10;i += 2) verifier_assertrange(z3[i],"-110729625","110729625");
  for (int i = 1;i < 10;i += 2) verifier_assertrange(z3[i],"-55364812","55364812");
}
