#include "crypto_uint8.h"
#include "crypto_int32.h"
#include "verifier.h"
#include "fe.h"

int main()
{
  crypto_uint8 s[32];
  verifier_modulus vp("57896044618658097711785492504343953926634992332820282019728792003956564819949");

  for (int i = 0;i < 32;++i) s[i].inputunsignedchar();

  verifier_bigint vs;
  for (int i = 0;i < 32;++i) verifier_addlimb(&vs,s[i],i * 8);

  crypto_int32 h[10];

  fe_frombytes(h,s);

  verifier_bigint vh;
  verifier_limbs_10_255(&vh,h);

  verifier_assertequalmod(&vh,&vs,vp);

  return 0;
}
