#include "verifier.h"
#include "fe.h"

verifier_modulus vp("57896044618658097711785492504343953926634992332820282019728792003956564819949");

verifier_bigint Z;

void fe_invert(crypto_int32 *out,const crypto_int32 *z)
{
  fe t0;
  fe t1;
  fe t2;
  fe t3;
  int i;

  verifier_bigint T0;
  verifier_bigint T1;
  verifier_bigint T2;
  verifier_bigint T3;
  verifier_bigint T;

/* qhasm: fe z1 */

/* qhasm: fe z2 */

/* qhasm: fe z8 */

/* qhasm: fe z9 */

/* qhasm: fe z11 */

/* qhasm: fe z22 */

/* qhasm: fe z_5_0 */

/* qhasm: fe z_10_5 */

/* qhasm: fe z_10_0 */

/* qhasm: fe z_20_10 */

/* qhasm: fe z_20_0 */

/* qhasm: fe z_40_20 */

/* qhasm: fe z_40_0 */

/* qhasm: fe z_50_10 */

/* qhasm: fe z_50_0 */

/* qhasm: fe z_100_50 */

/* qhasm: fe z_100_0 */

/* qhasm: fe z_200_100 */

/* qhasm: fe z_200_0 */

/* qhasm: fe z_250_50 */

/* qhasm: fe z_250_0 */

/* qhasm: fe z_255_5 */

/* qhasm: fe z_255_21 */

/* qhasm: enter pow225521 */

/* qhasm: z2 = z1^2^1 */
/* asm 1: fe_sq(>z2=fe#1,<z1=fe#11); for (i = 1;i < 1;++i) fe_sq(>z2=fe#1,>z2=fe#1); */
/* asm 2: fe_sq(>z2=t0,<z1=z); for (i = 1;i < 1;++i) fe_sq(>z2=t0,>z2=t0); */
fe_sq(t0,z);

  verifier_limbs_10_255(&T0,t0);
  verifier_assertprodmod(&T0,&Z,&Z,vp);
  verifier_cutlimbs(t0,10);

/* qhasm: z8 = z2^2^2 */
/* asm 1: fe_sq(>z8=fe#2,<z2=fe#1); for (i = 1;i < 2;++i) fe_sq(>z8=fe#2,>z8=fe#2); */
/* asm 2: fe_sq(>z8=t1,<z2=t0); for (i = 1;i < 2;++i) fe_sq(>z8=t1,>z8=t1); */
fe_sq(t1,t0);

  verifier_limbs_10_255(&T1,t1);
  verifier_assertprodmod(&T1,&T0,&T0,vp);
  verifier_cutlimbs(t1,10);

for (i = 1;i < 2;++i) {
  fe_sq(t1,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T1,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);
}

/* qhasm: z9 = z1*z8 */
/* asm 1: fe_mul(>z9=fe#2,<z1=fe#11,<z8=fe#2); */
/* asm 2: fe_mul(>z9=t1,<z1=z,<z8=t1); */
fe_mul(t1,z,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T1,&Z,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);

/* qhasm: z11 = z2*z9 */
/* asm 1: fe_mul(>z11=fe#1,<z2=fe#1,<z9=fe#2); */
/* asm 2: fe_mul(>z11=t0,<z2=t0,<z9=t1); */
fe_mul(t0,t0,t1);
  verifier_limbs_10_255(&T,t0);
  verifier_assertprodmod(&T,&T0,&T1,vp);
  T0 = T;
  verifier_cutlimbs(t0,10);

/* qhasm: z22 = z11^2^1 */
/* asm 1: fe_sq(>z22=fe#3,<z11=fe#1); for (i = 1;i < 1;++i) fe_sq(>z22=fe#3,>z22=fe#3); */
/* asm 2: fe_sq(>z22=t2,<z11=t0); for (i = 1;i < 1;++i) fe_sq(>z22=t2,>z22=t2); */
fe_sq(t2,t0);
  verifier_limbs_10_255(&T2,t2);
  verifier_assertprodmod(&T2,&T0,&T0,vp);
  verifier_cutlimbs(t2,10);

/* qhasm: z_5_0 = z9*z22 */
/* asm 1: fe_mul(>z_5_0=fe#2,<z9=fe#2,<z22=fe#3); */
/* asm 2: fe_mul(>z_5_0=t1,<z9=t1,<z22=t2); */
fe_mul(t1,t1,t2);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T1,&T2,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);

/* qhasm: z_10_5 = z_5_0^2^5 */
/* asm 1: fe_sq(>z_10_5=fe#3,<z_5_0=fe#2); for (i = 1;i < 5;++i) fe_sq(>z_10_5=fe#3,>z_10_5=fe#3); */
/* asm 2: fe_sq(>z_10_5=t2,<z_5_0=t1); for (i = 1;i < 5;++i) fe_sq(>z_10_5=t2,>z_10_5=t2); */
fe_sq(t2,t1);
  verifier_limbs_10_255(&T2,t2);
  verifier_assertprodmod(&T2,&T1,&T1,vp);
  verifier_cutlimbs(t2,10);

for (i = 1;i < 5;++i) {
  fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
}

/* qhasm: z_10_0 = z_10_5*z_5_0 */
/* asm 1: fe_mul(>z_10_0=fe#2,<z_10_5=fe#3,<z_5_0=fe#2); */
/* asm 2: fe_mul(>z_10_0=t1,<z_10_5=t2,<z_5_0=t1); */
fe_mul(t1,t2,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T2,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);

/* qhasm: z_20_10 = z_10_0^2^10 */
/* asm 1: fe_sq(>z_20_10=fe#3,<z_10_0=fe#2); for (i = 1;i < 10;++i) fe_sq(>z_20_10=fe#3,>z_20_10=fe#3); */
/* asm 2: fe_sq(>z_20_10=t2,<z_10_0=t1); for (i = 1;i < 10;++i) fe_sq(>z_20_10=t2,>z_20_10=t2); */
fe_sq(t2,t1);
  verifier_limbs_10_255(&T2,t2);
  verifier_assertprodmod(&T2,&T1,&T1,vp);
  verifier_cutlimbs(t2,10);
for (i = 1;i < 10;++i) {
  fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
}

/* qhasm: z_20_0 = z_20_10*z_10_0 */
/* asm 1: fe_mul(>z_20_0=fe#3,<z_20_10=fe#3,<z_10_0=fe#2); */
/* asm 2: fe_mul(>z_20_0=t2,<z_20_10=t2,<z_10_0=t1); */
fe_mul(t2,t2,t1);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T1,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);

/* qhasm: z_40_20 = z_20_0^2^20 */
/* asm 1: fe_sq(>z_40_20=fe#4,<z_20_0=fe#3); for (i = 1;i < 20;++i) fe_sq(>z_40_20=fe#4,>z_40_20=fe#4); */
/* asm 2: fe_sq(>z_40_20=t3,<z_20_0=t2); for (i = 1;i < 20;++i) fe_sq(>z_40_20=t3,>z_40_20=t3); */
fe_sq(t3,t2);
  verifier_limbs_10_255(&T3,t3);
  verifier_assertprodmod(&T3,&T2,&T2,vp);
  verifier_cutlimbs(t3,10);
for (i = 1;i < 20;++i) {
  fe_sq(t3,t3);
  verifier_limbs_10_255(&T,t3);
  verifier_assertprodmod(&T,&T3,&T3,vp);
  T3 = T;
  verifier_cutlimbs(t3,10);
}

/* qhasm: z_40_0 = z_40_20*z_20_0 */
/* asm 1: fe_mul(>z_40_0=fe#3,<z_40_20=fe#4,<z_20_0=fe#3); */
/* asm 2: fe_mul(>z_40_0=t2,<z_40_20=t3,<z_20_0=t2); */
fe_mul(t2,t3,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T3,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);

/* qhasm: z_50_10 = z_40_0^2^10 */
/* asm 1: fe_sq(>z_50_10=fe#3,<z_40_0=fe#3); for (i = 1;i < 10;++i) fe_sq(>z_50_10=fe#3,>z_50_10=fe#3); */
/* asm 2: fe_sq(>z_50_10=t2,<z_40_0=t2); for (i = 1;i < 10;++i) fe_sq(>z_50_10=t2,>z_50_10=t2); */
fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
for (i = 1;i < 10;++i) {
  fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
}

/* qhasm: z_50_0 = z_50_10*z_10_0 */
/* asm 1: fe_mul(>z_50_0=fe#2,<z_50_10=fe#3,<z_10_0=fe#2); */
/* asm 2: fe_mul(>z_50_0=t1,<z_50_10=t2,<z_10_0=t1); */
fe_mul(t1,t2,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T2,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);

/* qhasm: z_100_50 = z_50_0^2^50 */
/* asm 1: fe_sq(>z_100_50=fe#3,<z_50_0=fe#2); for (i = 1;i < 50;++i) fe_sq(>z_100_50=fe#3,>z_100_50=fe#3); */
/* asm 2: fe_sq(>z_100_50=t2,<z_50_0=t1); for (i = 1;i < 50;++i) fe_sq(>z_100_50=t2,>z_100_50=t2); */
fe_sq(t2,t1);
  verifier_limbs_10_255(&T2,t2);
  verifier_assertprodmod(&T2,&T1,&T1,vp);
  verifier_cutlimbs(t2,10);
for (i = 1;i < 50;++i) {
  fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
}

/* qhasm: z_100_0 = z_100_50*z_50_0 */
/* asm 1: fe_mul(>z_100_0=fe#3,<z_100_50=fe#3,<z_50_0=fe#2); */
/* asm 2: fe_mul(>z_100_0=t2,<z_100_50=t2,<z_50_0=t1); */
fe_mul(t2,t2,t1);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T1,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);

/* qhasm: z_200_100 = z_100_0^2^100 */
/* asm 1: fe_sq(>z_200_100=fe#4,<z_100_0=fe#3); for (i = 1;i < 100;++i) fe_sq(>z_200_100=fe#4,>z_200_100=fe#4); */
/* asm 2: fe_sq(>z_200_100=t3,<z_100_0=t2); for (i = 1;i < 100;++i) fe_sq(>z_200_100=t3,>z_200_100=t3); */
fe_sq(t3,t2);
  verifier_limbs_10_255(&T3,t3);
  verifier_assertprodmod(&T3,&T2,&T2,vp);
  verifier_cutlimbs(t3,10);
for (i = 1;i < 100;++i) {
  fe_sq(t3,t3);
  verifier_limbs_10_255(&T,t3);
  verifier_assertprodmod(&T,&T3,&T3,vp);
  T3 = T;
  verifier_cutlimbs(t3,10);
}

/* qhasm: z_200_0 = z_200_100*z_100_0 */
/* asm 1: fe_mul(>z_200_0=fe#3,<z_200_100=fe#4,<z_100_0=fe#3); */
/* asm 2: fe_mul(>z_200_0=t2,<z_200_100=t3,<z_100_0=t2); */
fe_mul(t2,t3,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T3,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);

/* qhasm: z_250_50 = z_200_0^2^50 */
/* asm 1: fe_sq(>z_250_50=fe#3,<z_200_0=fe#3); for (i = 1;i < 50;++i) fe_sq(>z_250_50=fe#3,>z_250_50=fe#3); */
/* asm 2: fe_sq(>z_250_50=t2,<z_200_0=t2); for (i = 1;i < 50;++i) fe_sq(>z_250_50=t2,>z_250_50=t2); */
fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
for (i = 1;i < 50;++i) {
  fe_sq(t2,t2);
  verifier_limbs_10_255(&T,t2);
  verifier_assertprodmod(&T,&T2,&T2,vp);
  T2 = T;
  verifier_cutlimbs(t2,10);
}

/* qhasm: z_250_0 = z_250_50*z_50_0 */
/* asm 1: fe_mul(>z_250_0=fe#2,<z_250_50=fe#3,<z_50_0=fe#2); */
/* asm 2: fe_mul(>z_250_0=t1,<z_250_50=t2,<z_50_0=t1); */
fe_mul(t1,t2,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T2,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);

/* qhasm: z_255_5 = z_250_0^2^5 */
/* asm 1: fe_sq(>z_255_5=fe#2,<z_250_0=fe#2); for (i = 1;i < 5;++i) fe_sq(>z_255_5=fe#2,>z_255_5=fe#2); */
/* asm 2: fe_sq(>z_255_5=t1,<z_250_0=t1); for (i = 1;i < 5;++i) fe_sq(>z_255_5=t1,>z_255_5=t1); */
fe_sq(t1,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T1,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);
for (i = 1;i < 5;++i) {
  fe_sq(t1,t1);
  verifier_limbs_10_255(&T,t1);
  verifier_assertprodmod(&T,&T1,&T1,vp);
  T1 = T;
  verifier_cutlimbs(t1,10);
}

/* qhasm: z_255_21 = z_255_5*z11 */
/* asm 1: fe_mul(>z_255_21=fe#12,<z_255_5=fe#2,<z11=fe#1); */
/* asm 2: fe_mul(>z_255_21=out,<z_255_5=t1,<z11=t0); */
fe_mul(out,t1,t0);
  verifier_limbs_10_255(&Z,out);
  verifier_assertprodmod(&Z,&T1,&T0,vp);
  verifier_cutlimbs(out,10);

/* qhasm: return */

  return;
}

// XXX: does not include masking of n
// XXX: does not include masking of p

int crypto_scalarmult(crypto_uint8 *q,
  const crypto_uint8 *n,
  const crypto_uint8 *p)
{
  int pos;
  fe x1; verifier_bigint X1;
  fe x2; verifier_bigint X2;
  fe z2; verifier_bigint Z2;
  fe x3; verifier_bigint X3;
  fe z3; verifier_bigint Z3;
  fe tmp0;
  fe tmp1;
  crypto_uint8 swap;
  crypto_uint8 b;

  verifier_bigint ninput;
  for (int i = 0;i < 32;++i) verifier_addlimb(&ninput,n[i],i * 8);

  verifier_bigint pinput;
  for (int i = 0;i < 32;++i) verifier_addlimb(&pinput,p[i],i * 8);

  verifier_input(&pinput);
  verifier_input(&ninput);

  fe_frombytes(x1,p);

  verifier_limbs_10_255(&X1,x1);
  verifier_assertequalmod(&X1,&pinput,vp);
  verifier_cutlimbs(x1,10);

  fe_1(x2);
  verifier_limbs_10_255(&X2,x2);
  verifier_assertconstant(&X2,1);

  fe_0(z2);
  verifier_limbs_10_255(&Z2,z2);
  verifier_assertconstant(&Z2,0);

  fe_copy(x3,x1);
  verifier_limbs_10_255(&X3,x3);
  verifier_assertequal(&X3,&X1);

  fe_1(z3);
  verifier_limbs_10_255(&Z3,z3);
  verifier_assertconstant(&Z3,1);

  verifier_bigint a24;
  verifier_addlimb(&a24,crypto_int32(121666),0);
  verifier_assertconstant(&a24,121666);

  swap = 0;
  for (pos = 254;pos >= 0;--pos) {
    b = n[pos / 8] >> (pos & 7);
    b &= 1;
    verifier_assertbit(b,&ninput,pos);
    crypto_uint8 oldswap = swap; // XXX: only for verification
    swap ^= b;
    verifier_assertxor(swap,b,oldswap);

    fe_cswap(x2,x3,swap);

  verifier_bigint X2new;
  verifier_limbs_10_255(&X2new,x2);
  verifier_bigint X3new;
  verifier_limbs_10_255(&X3new,x3);
  verifier_assertcswap(&X2new,&X3new,&X2,&X3,swap);
  verifier_cutlimbs(x2,10);
  verifier_cutlimbs(x3,10);

  X2 = X2new;
  X3 = X3new;

    fe_cswap(z2,z3,swap);

  verifier_bigint Z2new;
  verifier_limbs_10_255(&Z2new,z2);
  verifier_bigint Z3new;
  verifier_limbs_10_255(&Z3new,z3);
  verifier_assertcswap(&Z2new,&Z3new,&Z2,&Z3,swap);

  verifier_cutlimbs(z2,10);
  verifier_cutlimbs(z3,10);

  Z2 = Z2new;
  Z3 = Z3new;

    swap = b;

/* qhasm: D = X3-Z3 */
/* asm 1: fe_sub(>D=fe#5,<X3=fe#3,<Z3=fe#4); */
/* asm 2: fe_sub(>D=tmp0,<X3=x3,<Z3=z3); */
fe_sub(tmp0,x3,z3);

  verifier_bigint D;
  verifier_limbs_10_255(&D,tmp0);
  verifier_assertdiff(&D,&X3,&Z3);
  verifier_cutlimbs(tmp0,10);

/* qhasm: B = X2-Z2 */
/* asm 1: fe_sub(>B=fe#6,<X2=fe#1,<Z2=fe#2); */
/* asm 2: fe_sub(>B=tmp1,<X2=x2,<Z2=z2); */
fe_sub(tmp1,x2,z2);

  verifier_bigint B;
  verifier_limbs_10_255(&B,tmp1);
  verifier_assertdiff(&B,&X2,&Z2);
  verifier_cutlimbs(tmp1,10);

/* qhasm: A = X2+Z2 */
/* asm 1: fe_add(>A=fe#1,<X2=fe#1,<Z2=fe#2); */
/* asm 2: fe_add(>A=x2,<X2=x2,<Z2=z2); */
fe_add(x2,x2,z2);

  verifier_bigint A;
  verifier_limbs_10_255(&A,x2);
  verifier_assertsum(&A,&X2,&Z2);
  verifier_cutlimbs(x2,10);

/* qhasm: C = X3+Z3 */
/* asm 1: fe_add(>C=fe#2,<X3=fe#3,<Z3=fe#4); */
/* asm 2: fe_add(>C=z2,<X3=x3,<Z3=z3); */
fe_add(z2,x3,z3);

  verifier_bigint C;
  verifier_limbs_10_255(&C,z2);
  verifier_assertsum(&C,&X3,&Z3);
  verifier_cutlimbs(z2,10);

/* qhasm: DA = D*A */
/* asm 1: fe_mul(>DA=fe#4,<D=fe#5,<A=fe#1); */
/* asm 2: fe_mul(>DA=z3,<D=tmp0,<A=x2); */
fe_mul(z3,tmp0,x2);

  verifier_bigint DA;
  verifier_limbs_10_255(&DA,z3);
  verifier_assertprodmod(&DA,&D,&A,vp);
  verifier_cutlimbs(z3,10);

/* qhasm: CB = C*B */
/* asm 1: fe_mul(>CB=fe#2,<C=fe#2,<B=fe#6); */
/* asm 2: fe_mul(>CB=z2,<C=z2,<B=tmp1); */
fe_mul(z2,z2,tmp1);

  verifier_bigint CB;
  verifier_limbs_10_255(&CB,z2);
  verifier_assertprodmod(&CB,&C,&B,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: BB = B^2 */
/* asm 1: fe_sq(>BB=fe#5,<B=fe#6); */
/* asm 2: fe_sq(>BB=tmp0,<B=tmp1); */
fe_sq(tmp0,tmp1);

  verifier_bigint BB;
  verifier_limbs_10_255(&BB,tmp0);
  verifier_assertprodmod(&BB,&B,&B,vp);
  verifier_cutlimbs(tmp0,10);

/* qhasm: AA = A^2 */
/* asm 1: fe_sq(>AA=fe#6,<A=fe#1); */
/* asm 2: fe_sq(>AA=tmp1,<A=x2); */
fe_sq(tmp1,x2);

  verifier_bigint AA;
  verifier_limbs_10_255(&AA,tmp1);
  verifier_assertprodmod(&AA,&A,&A,vp);
  verifier_cutlimbs(tmp1,10);

/* qhasm: t0 = DA+CB */
/* asm 1: fe_add(>t0=fe#3,<DA=fe#4,<CB=fe#2); */
/* asm 2: fe_add(>t0=x3,<DA=z3,<CB=z2); */
fe_add(x3,z3,z2);

  verifier_bigint t0;
  verifier_limbs_10_255(&t0,x3);
  verifier_assertsum(&t0,&DA,&CB);
  verifier_cutlimbs(x3,10);

/* qhasm: assign x3 to t0 */

/* qhasm: t1 = DA-CB */
/* asm 1: fe_sub(>t1=fe#2,<DA=fe#4,<CB=fe#2); */
/* asm 2: fe_sub(>t1=z2,<DA=z3,<CB=z2); */
fe_sub(z2,z3,z2);

  verifier_bigint t1;
  verifier_limbs_10_255(&t1,z2);
  verifier_assertdiff(&t1,&DA,&CB);
  verifier_cutlimbs(z2,10);

/* qhasm: X4 = AA*BB */
/* asm 1: fe_mul(>X4=fe#1,<AA=fe#6,<BB=fe#5); */
/* asm 2: fe_mul(>X4=x2,<AA=tmp1,<BB=tmp0); */
fe_mul(x2,tmp1,tmp0);

  verifier_limbs_10_255(&X2,x2);
  verifier_assertprodmod(&X2,&AA,&BB,vp);
  verifier_cutlimbs(x2,10);

/* qhasm: E = AA-BB */
/* asm 1: fe_sub(>E=fe#6,<AA=fe#6,<BB=fe#5); */
/* asm 2: fe_sub(>E=tmp1,<AA=tmp1,<BB=tmp0); */
fe_sub(tmp1,tmp1,tmp0);

  verifier_bigint E;
  verifier_limbs_10_255(&E,tmp1);
  verifier_assertdiff(&E,&AA,&BB);
  verifier_cutlimbs(tmp1,10);

/* qhasm: t2 = t1^2 */
/* asm 1: fe_sq(>t2=fe#2,<t1=fe#2); */
/* asm 2: fe_sq(>t2=z2,<t1=z2); */
fe_sq(z2,z2);

  verifier_bigint t2;
  verifier_limbs_10_255(&t2,z2);
  verifier_assertprodmod(&t2,&t1,&t1,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: t3 = a24*E */
/* asm 1: fe_mul121666(>t3=fe#4,<E=fe#6); */
/* asm 2: fe_mul121666(>t3=z3,<E=tmp1); */
fe_mul121666(z3,tmp1);

  verifier_bigint t3;
  verifier_limbs_10_255(&t3,z3);
  verifier_assertprodmod(&t3,&a24,&E,vp);
  verifier_cutlimbs(z3,10);
  
/* qhasm: X5 = t0^2 */
/* asm 1: fe_sq(>X5=fe#3,<t0=fe#3); */
/* asm 2: fe_sq(>X5=x3,<t0=x3); */
fe_sq(x3,x3);

  verifier_limbs_10_255(&X3,x3);
  verifier_assertprodmod(&X3,&t0,&t0,vp);
  verifier_cutlimbs(x3,10);

/* qhasm: t4 = BB+t3 */
/* asm 1: fe_add(>t4=fe#5,<BB=fe#5,<t3=fe#4); */
/* asm 2: fe_add(>t4=tmp0,<BB=tmp0,<t3=z3); */
fe_add(tmp0,tmp0,z3);

  verifier_bigint t4;
  verifier_limbs_10_255(&t4,tmp0);
  verifier_assertsum(&t4,&BB,&t3);
  verifier_cutlimbs(tmp0,10);

/* qhasm: Z5 = X1*t2 */
/* asm 1: fe_mul(>Z5=fe#4,x1,<t2=fe#2); */
/* asm 2: fe_mul(>Z5=z3,x1,<t2=z2); */
fe_mul(z3,x1,z2);

  verifier_limbs_10_255(&Z3,z3);
  verifier_assertprodmod(&Z3,&X1,&t2,vp);
  verifier_cutlimbs(z3,10);

/* qhasm: Z4 = E*t4 */
/* asm 1: fe_mul(>Z4=fe#2,<E=fe#6,<t4=fe#5); */
/* asm 2: fe_mul(>Z4=z2,<E=tmp1,<t4=tmp0); */
fe_mul(z2,tmp1,tmp0);

  verifier_limbs_10_255(&Z2,z2);
  verifier_assertprodmod(&Z2,&E,&t4,vp);
  verifier_cutlimbs(z2,10);

/* qhasm: return */

  verifier_highlevelcut(&X2);
  verifier_highlevelcut(&X3);
  verifier_highlevelcut(&Z2);
  verifier_highlevelcut(&Z3);

  }

  fe_cswap(x2,x3,swap);

  verifier_bigint X2new;
  verifier_limbs_10_255(&X2new,x2);
  verifier_bigint X3new;
  verifier_limbs_10_255(&X3new,x3);
  verifier_assertcswap(&X2new,&X3new,&X2,&X3,swap);
  verifier_cutlimbs(x2,10);
  verifier_cutlimbs(x3,10);

  X2 = X2new;

  fe_cswap(z2,z3,swap);

  verifier_bigint Z2new;
  verifier_limbs_10_255(&Z2new,z2);
  verifier_bigint Z3new;
  verifier_limbs_10_255(&Z3new,z3);
  verifier_assertcswap(&Z2new,&Z3new,&Z2,&Z3,swap);
  verifier_cutlimbs(z2,10);

  Z = Z2new;

  verifier_highlevelcut(&X2);
  verifier_highlevelcut(&Z);

  fe_invert(z2,z2);

  fe_mul(x2,x2,z2);

  int flagnegative = 0;
  for (int i = 9;i >= 0;--i) {
    if (verifier_isnegative(x2[i])) { flagnegative = 1; break; }
    if (i == 0) break;
    if (verifier_ispositive(x2[i])) { flagnegative = 0; break; }
  }
  
  verifier_limbs_10_255(&X2new,x2);
  verifier_assertprodmod(&X2new,&X2,&Z,vp);
  verifier_cutlimbs(x2,10);

  fe_tobytes(q,x2);

  verifier_bigint vq;
  for (int i = 0;i < 32;++i) verifier_addlimb(&vq,q[i],i * 8);
  verifier_assertequalmod(&vq,&X2new,vp);

  crypto_int32 mod[10] = {
    67108845, 33554431,
    67108863, 33554431,
    67108863, 33554431,
    67108863, 33554431,
    67108863, 33554431
  };
  verifier_bigint vp;
  verifier_limbs_10_255(&vp,mod);
  if (flagnegative) verifier_assertsum(&vq,&X2new,&vp);

  verifier_assertrange(&vq,"0","57896044618658097711785492504343953926634992332820282019728792003956564819948");

  verifier_output(&vq);

  return 0;
}

int main()
{
  crypto_uint8 n[32];
  crypto_uint8 p[32];
  crypto_uint8 q[32];

  for (int i = 0;i < 32;++i) n[i].inputunsignedchar();
  for (int i = 0;i < 32;++i) p[i].inputunsignedchar();

  crypto_scalarmult(q,n,p);

  return 0;
}
