#include "crypto_uint8.h"
#include "crypto_int32.h"
#include "verifier.h"
#include "fe.h"

int main()
{
  crypto_int32 p[10] = {
    67108845, 33554431,
    67108863, 33554431,
    67108863, 33554431,
    67108863, 33554431,
    67108863, 33554431
  };
  crypto_int32 g[10];
  crypto_int32 h[10];
  crypto_uint8 s[32];
  verifier_modulus vp("57896044618658097711785492504343953926634992332820282019728792003956564819949");

  for (int i = 0;i < 10;++i) g[i].inputint();
  for (int i = 0;i < 10;i += 2) verifier_assumerange(g[i],"-36909876","36909876");
  for (int i = 1;i < 10;i += 2) verifier_assumerange(g[i],"-18454938","18454938");

  verifier_bigint vg;
  verifier_limbs_10_255(&vg,g);
  fe_mul(h,g,g);


  verifier_bigint vh;
  verifier_limbs_10_255(&vh,h);
  verifier_assertprodmod(&vh,&vg,&vg,vp);


  // verifier_cutlimbs(h,10);

  int flagnegative = 0;
  for (int i = 9;i >= 0;--i) {
    if (verifier_isnegative(h[i])) { flagnegative = 1; break; }
    if (i == 0) break;
    if (verifier_ispositive(h[i])) { flagnegative = 0; break; }
  }

/*

  verifier_limbs_10_255(&vh,h);

  fe_tobytes(s,h);

  verifier_bigint vs;
  for (int i = 0;i < 32;++i) verifier_addlimb(&vs,s[i],i * 8);

  verifier_assertequalmod(&vs,&vh,vp);

  verifier_bigint vp;
  verifier_limbs_10_255(&vp,p);

  if (flagnegative) verifier_assertsum(&vs,&vh,&vp);
  verifier_assertrange(&vs,"0","57896044618658097711785492504343953926634992332820282019728792003956564819948");

*/

  return 0;
}
